/*************************************************************************
*
* YahooPOPs!
*
* YahooPOPs! is an application that provides POP3 access to Yahoo! Mail.
* You do not need to enable POP3 access with Yahoo! to use this program.
* This program works within the license agreement of Yahoo! to provide
* you with POP3 access.
*
* YahooPOPs! emulates a POP3 mail server and should work with most of the
* email clients. Since YahooPOPs! is not a full-fledged POP3 mail server
* you might find it not working with all mail clients. Do keep us informed
* about such mail clients so that we can enhance YahooPOPs!
*
* Official Website: http://yahoopops.sourceforge.net
*
*-------------------------------------------------------------------------
*
* Name    :	ConfigEmailPage.cpp
*
* Purpose : Configuration Dialog - Email Page
*
* Authors : Anuj Seth
*
* License : GNU Public License (Version 2 or later)
*
*-------------------------------------------------------------------------
*
* THIS SOFTWARE IS PROVIDED ``AS IS'' BY THE AUTHORS AND INDEPENDENT
* CONTRIBUTORS AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR 
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*************************************************************************/
#include "stdafx.h"

#ifdef WIN32
#include "yahoopops.h"
#include "ConfigEmailPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CDataHolder settings;

IMPLEMENT_DYNCREATE(CConfigEmailPage, CPropertyPage)

CConfigEmailPage::CConfigEmailPage() : CCustomPropertyPage(CConfigEmailPage::IDD)
{
	//{{AFX_DATA_INIT(CConfigEmailPage)
	m_nEmailCategory = -1;
	m_bEmptyTrash = FALSE;
	m_bEnableBulkMail = FALSE;
	m_bEnableInbox = FALSE;
	m_nMaxEmails = 10000;
	m_bLeaveUnread = FALSE;
	m_bEmptyBulkMail = FALSE;
	//}}AFX_DATA_INIT
}

CConfigEmailPage::~CConfigEmailPage()
{
}

void CConfigEmailPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigEmailPage)
	DDX_Radio(pDX, IDC_EMAIL_CATEGORY, m_nEmailCategory);
	DDX_Check(pDX, IDC_EMPTY_TRASH, m_bEmptyTrash);
	DDX_Check(pDX, IDC_ENABLE_BULKMAIL, m_bEnableBulkMail);
	DDX_Check(pDX, IDC_ENABLE_INBOX, m_bEnableInbox);
	DDX_Text(pDX, IDC_MAX_EMAILS, m_nMaxEmails);
	DDV_MinMaxUInt(pDX, m_nMaxEmails, 1, 10000);
	DDX_Check(pDX, IDC_LEAVE_UNREAD, m_bLeaveUnread);
	DDX_Check(pDX, IDC_EMPTY_BULK_MAIL, m_bEmptyBulkMail);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigEmailPage, CCustomPropertyPage)
	//{{AFX_MSG_MAP(CConfigEmailPage)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CConfigEmailPage::Init(CDataHolder &data)
{
	m_nEmailCategory = (data.m_nEmailCategory == EC_ALL ? 0 :
						(data.m_nEmailCategory == EC_UNREAD ? 1 : 2));
	m_bEmptyTrash    = data.m_bEmptyTrash;
	m_bEnableBulkMail= data.m_bBulkMail;
	m_bEnableInbox   = data.m_bInbox;
	m_nMaxEmails     = data.m_nMaxEmails;
	m_bLeaveUnread	 = data.m_bLeaveUnread;
	m_bEmptyBulkMail = data.m_bEmptyBulkMail;

	UpdateData(FALSE);
}

BOOL CConfigEmailPage::ValidateData(void)
{
	UpdateData(TRUE);

/*	if(!m_bEnableBulkMail && !m_bEnableInbox)
	{
		::AfxMessageBox("Select Inbox and/or Bulk Mail download", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
*/
	return TRUE;
}

void CConfigEmailPage::SaveData(CDataHolder &data)
{
	settings.m_nEmailCategory= m_nEmailCategory == 0 ? EC_ALL :
							   (m_nEmailCategory == 1 ? EC_UNREAD : EC_FLAGGED);
	settings.m_bEmptyTrash	 = m_bEmptyTrash;
	settings.m_bBulkMail	 = m_bEnableBulkMail;
	settings.m_bInbox		 = m_bEnableInbox;
	settings.m_nMaxEmails	 = m_nMaxEmails;
	settings.m_bLeaveUnread	 = m_bLeaveUnread;
	settings.m_bEmptyBulkMail= m_bEmptyBulkMail;

	data.m_nEmailCategory	= m_nEmailCategory == 0 ? EC_ALL :
							   (m_nEmailCategory == 1 ? EC_UNREAD : EC_FLAGGED);
	data.m_bEmptyTrash		= m_bEmptyTrash;
	data.m_bBulkMail		= m_bEnableBulkMail;
	data.m_bInbox			= m_bEnableInbox;
	data.m_nMaxEmails		= m_nMaxEmails;
	data.m_bLeaveUnread		= m_bLeaveUnread;
	data.m_bEmptyBulkMail   = m_bEmptyBulkMail;
}
#endif
