/*************************************************************************
*
* YahooPOPs!
*
* YahooPOPs! is an application that provides POP3 access to Yahoo! Mail.
* You do not need to enable POP3 access with Yahoo! to use this program.
* This program works within the license agreement of Yahoo! to provide
* you with POP3 access.
*
* YahooPOPs! emulates a POP3 mail server and should work with most of the
* email clients. Since YahooPOPs! is not a full-fledged POP3 mail server
* you might find it not working with all mail clients. Do keep us informed
* about such mail clients so that we can enhance YahooPOPs!
*
* Official Website: http://yahoopops.sourceforge.net
*
*-------------------------------------------------------------------------
*
* Name    :	OptionsTreeDlg.h
*
* Purpose : Dialog to configure YahooPOPs!
*
* Authors : Anuj Seth
* 			K.Shyam
*
* License : GNU Public License (Version 2 or later)
*
*-------------------------------------------------------------------------
*
* THIS SOFTWARE IS PROVIDED ``AS IS'' BY THE AUTHORS AND INDEPENDENT
* CONTRIBUTORS AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR 
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*************************************************************************/
#ifdef WIN32
#ifndef _CONFIGURE_YP_H_
#define _CONFIGURE_YP_H_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "resource.h"
#include "ConfigAdvancedPage.h"
#include "ConfigSecurityPage.h"
#include "ConfigProxyPage.h"
#include "ConfigEmailPreferencesPage.h"
#include "ConfigEmailPage.h"
#include "ConfigMiscPage.h"
#include "ConfigNetWorkPage.h"
#include "ConfigLogPage.h"
#include "ConfigFoldersPage.h"
#include "ConfigMailSmtpPage.h"

#include "DataHolder.h"

class COptionsTreeDlg : public CDialog
{
public:
	COptionsTreeDlg(CWnd* pParent = NULL);

	//{{AFX_DATA(COptionsTreeDlg)
	enum { IDD = IDD_OPTIONSTREE_DIALOG };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionsTreeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

protected:
	CImageList* pInfoImages;
	CTreeCtrl	m_Tree;
	bool		m_bDlgCreated;
	CDataHolder	data;

	CConfigAdvancedPage			m_pageAdvanced;
	CConfigSecurityPage			m_pageSecurity;
	CConfigProxyPage			m_pageProxy;
	CConfigEmailPreferencesPage m_pageEmailPref;
	CConfigEmailPage			m_pageEmail;
	CConfigMiscPage				m_pageMisc;
	CConfigNetworkPage			m_pageNetwork;
	CConfigLogPage				m_pageLog;
	CConfigFoldersPage			m_pageFolders;
    CConfigMailSmtpPage         m_pageMailSmtp;

	// Generated message map functions
	//{{AFX_MSG(COptionsTreeDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangingTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDestroy();
	virtual void OnOK();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif
#endif

