/*************************************************************************
*
* YahooPOPs!
*
* YahooPOPs! is an application that provides POP3 access to Yahoo! Mail.
* You do not need to enable POP3 access with Yahoo! to use this program.
* This program works within the license agreement of Yahoo! to provide
* you with POP3 access.
*
* YahooPOPs! emulates a POP3 mail server and should work with most of the
* email clients. Since YahooPOPs! is not a full-fledged POP3 mail server
* you might find it not working with all mail clients. Do keep us informed
* about such mail clients so that we can enhance YahooPOPs!
*
* Official Website: http://yahoopops.sourceforge.net
*
*-------------------------------------------------------------------------
*
* Name    :	ServiceClient.h
*
* Purpose : Class to service a new POP3 connection
*
* Authors : Anuj Seth & K Shyam
*
* License : GNU Public License (Version 2 or later)
*
*-------------------------------------------------------------------------
*
* THIS SOFTWARE IS PROVIDED ``AS IS'' BY THE AUTHORS AND INDEPENDENT
* CONTRIBUTORS AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR 
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*************************************************************************/
#ifndef _SERVICE_CLIENT_H_
#define _SERVICE_CLIENT_H_

#ifndef WIN32
typedef int SOCKET;
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/time.h>
#if defined(sparc)
#define INADDR_NONE ((unsigned long)0xFFFFFFFF)
#endif
#define UINT unsigned int

#endif

#include "WebBrowser.h"

UINT ListenThread(void *lpParameter);
UINT ServiceClientThread(void *lpParameter);
UINT EmailDownloadStatusThread(void *lpParameter);
UINT ProgressThread(void *lpParameter);

class ServiceClient
{
public:
#ifdef WIN32
	ServiceClient(SOCKET sock);
#else
	ServiceClient(SOCKET *sock);
#endif
	
	~ServiceClient();

	int Execute();

protected:

#ifdef WIN32
	void SendError(int errorCode);
#else
	void SendError(char *str);
#endif
	
	/* POP3 Command Handlers */
	int ReadUser();
	int ReadPass();
	int ServiceSTAT();
	int ServiceLIST(char *buf);
	int ServiceRETR(char *buf);
	int ServiceDELE(char *buf);
	int ServiceNOOP();
	int ServiceRSET();
	int ServiceQUIT();
	int ServiceTOP(char *buf);
	int ServiceUIDL();

private:
	char username[80];
	char password[80];

	CWebBrowser browser;
	SOCKET sock;
	CStdString str;
	char buf[1024];
	int buflen;
	char *ptr;
};

#ifdef WIN32
typedef struct progress_data_t
{
	CEvent init;
	CEvent destroy;
	CProgressWnd *progress;

	progress_data_t()
	{
		progress = NULL;
		init.ResetEvent();
		destroy.ResetEvent();
	}

	~progress_data_t()
	{
		if(progress != NULL)
		{
			delete progress;
			progress = NULL;
		}
	}
} PROGRESS_DATA;
#else
typedef struct
{
    /* Dummy structure */
} PROGRESS_DATA;

#endif

#endif

